import 'package:flutter/cupertino.dart';

class IBlocBase {
  IBlocBase() {
    init();
  }

  void init() {}

  void dispose() {}
}

abstract class IBlocState<B extends IBlocBase, T extends StatefulWidget> extends State<T> {
  B? _bloc;

  B get bloc => _bloc ?? _internal();

  B _internal() {
    B bloc = initBloc();
    _bloc = bloc;
    return bloc;
  }

  @protected
  B initBloc();

  @override
  void dispose() {
    super.dispose();
    bloc.dispose();
  }
}

/*class IBlocProvider<T extends IBlocBase> extends StatefulWidget {
  final T bloc;
  final Widget child;
  final bool userDispose;
  final bool lazy;

  IBlocProvider({Key key, @required this.bloc, @required this.child, this.userDispose, this.lazy}) : super(key: key);

  @override
  _IBlocProviderState createState() => _IBlocProviderState();

  static T of<T extends IBlocBase>(BuildContext context) {
    IBlocProvider<T> provider = context.findAncestorWidgetOfExactType<IBlocProvider<T>>();
    return provider.bloc;
  }
}

class _IBlocProviderState extends State<IBlocProvider> {
  @override
  Widget build(BuildContext context) {
    return Container();
  }
}*/
