class Pair<A,B> {
  final A first;
  final B second;

  const Pair(this.first, this.second);

  @override
  String toString() {
    return "Pair($first,$second)";
  }

  @override
  bool operator ==(Object other) => identical(this, other) || other is Pair && runtimeType == other.runtimeType && first == other.first && second == other.second;

  @override
  int get hashCode => first.hashCode ^ second.hashCode;
}

class Triple<A,B,C> {
  final A first;
  final B second;
  final C three;

  const Triple(this.first, this.second, this.three);

  @override
  String toString() {
    return 'Triple{first: $first, second: $second, three: $three}';
  }

  @override
  bool operator ==(Object other) => identical(this, other) || other is Triple && runtimeType == other.runtimeType && first == other.first && second == other.second && three == other.three;

  @override
  int get hashCode => first.hashCode ^ second.hashCode ^ three.hashCode;
}

extension  dynamicExt on dynamic {
  Pair<A,B> pair<A,B>(B second) => Pair<A,B>(this, second);
}

