part of itwo_util;

class CacheUtil {
  static Future<SharedPreferences> get _sp async => await SharedPreferences.getInstance();

  static Future<bool> put(key, value) async {
    if (value is String) {
      return (await _sp).setString(key, value);
    } else if (value is int) {
      return (await _sp).setInt(key, value);
    } else if (value is double) {
      return (await _sp).setDouble(key, value);
    } else if (value is bool) {
      return (await _sp).setBool(key, value);
    } else if (value is List<String>) {
      return (await _sp).setStringList(key, value);
    } else {
      try {
        var encode = json.encode(value);
        return (await _sp).setString(key, encode);
      } catch (e) {
        print(e);
        return false;
      }
    }
  }

  static Future<dynamic> get(key) async => (await _sp).get(key);

  static Future<bool> remove(key) async => (await _sp).remove(key);
}
