part of itwo_util;

///  md5 base64 sha1
///  var sha1Str = hex.encode(sha1.convert(utf8.encode(data)).bytes);
class EncryptUtil {
  static String md5Encode(String data) {
    var content = Utf8Encoder().convert(data);
    var digest = md5.convert(content);
    return hex.encode(digest.bytes);
  }

  static String md5File(File file) {
    var digest = md5.convert(file.readAsBytesSync());
    return hex.encode(digest.bytes);
  }

  static Future<String> md5FileAsync(File file) async {
    var digest = await md5.bind(file.openRead()).first;
    return hex.encode(digest.bytes);
  }

  /// 字符串转 base64 编码
  static String base64Encode(String data) {
    var content = utf8.encode(data);
    var digest = base64.encode(content);
    return digest;
  }

  static String base64Decode(String data) {
    List<int> bytes = base64.decode(data);
    String result = utf8.decode(bytes);
    return result;
  }

  /// 文件转 base64
  static Future<String> base64EncodeFile(File file) async {
    List<int> bytes = await file.readAsBytes();
    return base64.encode(bytes);
  }

  /// base64 转存文件
  static Future<File> base64DecodeFile(String base64Str, File file) async {
    List<int> bytes = base64.decode(base64Str);
    return await file.writeAsBytes(bytes);
  }

  ///AES加密  ivStr 偏移量  ecb 模式不需要  http://tool.chacuo.net/cryptaes
  static aesEncrypt(String plainStr, String keyStr, {required String ivStr}) {
    try {
      final key = encrypt.Key.fromUtf8(keyStr);
      final iv = encrypt.IV.fromUtf8(ivStr);
      final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc));
      final encrypted = encrypter.encrypt(plainStr, iv: iv);
      return encrypted.base64;
    } catch (err) {
      print("aes encode error:$err");
      return plainStr;
    }
  }

  //AES解密
  static dynamic aesDecrypt(encrypted, String keyStr, {required String ivStr}) {
    try {
      final key = encrypt.Key.fromUtf8(keyStr);
      final iv = encrypt.IV.fromUtf8(ivStr);
      final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc));
      final decrypted = encrypter.decrypt64(encrypted, iv: iv);
      return decrypted;
    } catch (err) {
      print("aes decode error:$err");
      return encrypted;
    }
  }
}
