part of itwo_util;

extension StringExtNull on String? {
  bool get isNullOrEmpty => this == null || this?.length == 0;
}

extension StringExt on String {
  ///翻转字符
  String get reverse {
    if (this.isEmpty) return '';
    StringBuffer sb = StringBuffer();
    for (int i = length - 1; i >= 0; i--) {
      sb.writeCharCode(codeUnitAt(i));
    }
    return sb.toString();
  }

  int? toIntOrNull() => int.tryParse(this);

  double? toDoubleOrNull() => double.tryParse(this);

  Color toColor() {
    try {
      var c = this.replaceAll("#", "");
      if (c.length == 6) c = "FF" + c;
      return Color(int.parse(c, radix: 16));
    } catch (e) {
      throw 'Color parse error $e';
    }
  }

  String get htmlContent => _coverHtml(this);

  String _coverHtml(String content) {
    var html = """
    <html>
            <head>
              <meta charset="UTF-8">
            </head>
            <body  onload="SendHight()">
              $content
            </body>
        </html>
    """;
    String initialUrl = "data:text/html;charset=utf-8;base64,${base64Encode(const Utf8Encoder().convert(html))}";
    return initialUrl;
  }

  /// 需要先实现 Config 中的 toast 方法
  void toast() => Config.toast?.call(this);
}
